//+------------------------------------------------------------------+
//|                                                   ADXcrosses.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Blue
#property indicator_color2  DeepSkyBlue
#property indicator_color3  Red
#property indicator_color4  Violet
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    ADXPeriod = 14;
extern double DIpDImLevels = 30;

//
//
//
//
//

double UpH[];
double UpHH[];
double DnH[];
double DnHH[];
double trend[];
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

   IndicatorBuffers(5);
   SetIndexBuffer(0,UpH);    SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,UpHH);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,DnH);    SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,DnHH);   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,trend);

   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" DiPlus DiMinus cross");
return(0);
} 

int deinit() { return(0); }

//+------------------------------------------------------------------+
//| 
//+------------------------------------------------------------------+
//
//

int start()
{
    int counted_bars=IndicatorCounted();
    if(counted_bars<0) return(-1);
    if(counted_bars>0) counted_bars--;
          int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double nowplusdi  = iADX(NULL,timeFrame,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI, y);
      double nowminusdi = iADX(NULL,timeFrame,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,y);  
            UpH[i]   = EMPTY_VALUE;
            DnH[i]   = EMPTY_VALUE;
            UpHH[i]  = EMPTY_VALUE;
            DnHH[i]  = EMPTY_VALUE;
            trend[i] = trend[i+1];
         
            //
            //
            //
            //
            //
          
            if (nowplusdi>nowminusdi) trend[i] = 1;
            if (nowplusdi<nowminusdi) trend[i] =-1; 
            if (trend[i] == 1 && nowplusdi >DIpDImLevels)  { UpHH[i] = 1; continue; }
            if (trend[i] ==-1 && nowminusdi>DIpDImLevels)  { DnHH[i] = 1; continue; }
            if (trend[i] == 1)   UpH[i] = 1;
            if (trend[i] ==-1)   DnH[i] = 1;
    
    }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}


